package com.angrist.simplecamera;
import java.io.IOException;

import android.content.Context;
import android.hardware.Camera;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;


public class CameraPreview extends SurfaceView implements SurfaceHolder.Callback {
	public Boolean savePictures;
	private SurfaceHolder mHolder;
	private Camera mCamera;

	public CameraPreview(Context context, Camera camera){
		super(context);
		savePictures = false;
		mCamera = camera;
		mHolder = getHolder();
		mHolder.addCallback(this);
		mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
	}
	
	public void surfaceCreated(SurfaceHolder holder){
		try{
			mCamera.setPreviewDisplay(holder);
			mCamera.startPreview();
		}
		catch (IOException e){
			Log.d("CAMERA_PREVIEW", "Error setting camera preview" +e.getMessage());
		}
	}
	public void surfaceDestroyed(SurfaceHolder holder){
		// empty. Take care of releasing the Camera preview in activity.
	}
	public void surfaceChanged(SurfaceHolder holder, int format, int w, int h){
		// If preview can change or rotate take care of events here
		if (mHolder.getSurface() == null){
			//preview surface does not exist
			return;
		}
		
		//Stop preview before making changes
		try{
			mCamera.stopPreview();
		}
		catch (Exception e){
			//ignore tried to stop a non-existent preview
		}
		// set preview size and make any resize rotate or reformatting here
		
		//restart preview with new settings
		try{
			mCamera.setPreviewDisplay(mHolder);
			mCamera.startPreview();
		}
		catch (Exception e){
			Log.d("CAMERA_PREVIEW", "Error starting camera preview: " +e.getMessage());
		}
	}
}